unit Ctlarrex;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Ctlarray, Buttons, CtlArrE2, CtlHArr;

type
  TForm1 = class(TForm)
    CtlArray1: TCtlArray;
    ListBox1: TListBox;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button13: TButton;
    Button14: TButton;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    Button21: TButton;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    procedure ListBox1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button21Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    ListBoxLowDistance : integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
const
  BEGINING      = 0;
  CAPTION_PUT   = 1;
  SHRINKED      = 2;
  HIDEN         = 3;
  SHOWN         = 4;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  { Changing State of Controls }
  case CtlArray1.Tags[ListBox1.ItemIndex] of
    BEGINING    :
      (CtlArray1.Controls[ListBox1.ItemIndex] as TButton).Caption :=
        IntToStr(ListBox1.ItemIndex + 1);
    CAPTION_PUT :
      CtlArray1.Controls[ListBox1.ItemIndex].Height :=
       CtlArray1.Controls[ListBox1.ItemIndex].Height - 3;
    SHRINKED    :
      CtlArray1.Controls[ListBox1.ItemIndex].Visible := FALSE;
    HIDEN       :
      CtlArray1.Controls[ListBox1.ItemIndex].Visible := TRUE;
    SHOWN       :
      Application.MessageBox('Control Array Action',
       'Cannot do anymore actions on this control', 0);
  end; { case }
  CtlArray1.Tags[ListBox1.ItemIndex] := CtlArray1.Tags[ListBox1.ItemIndex] + 1;
end;

procedure TForm1.FormResize(Sender: TObject);
var
  CurCtl : integer;

begin
  { Resizing ListBox }
  ListBox1.Height := ClientHeight - ListBox1.Top - ListBoxLowDistance;

  { Puting Controls in new Position, According To There Tag Property }
  for CurCtl := 0 to CtlArray1.ControlCount - 1 do
    CtlArray1.Controls[CurCtl].Top := ClientHeight - CtlArray1.Controls[CurCtl].Tag;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  CurCtl : integer;

begin
  {Saving Distance Between Lower Point Of List Box and FormBorder }
  ListBoxLowDistance := ClientHeight - ListBox1.Height - ListBox1.Top;

  { Saving if The Buttons Tags There Distnces From FormBorder for
    Future Use in Resize Event }
  for CurCtl := 0 to CtlArray1.ControlCount - 1 do
    CtlArray1.Controls[CurCtl].Tag := ClientHeight -
     CtlArray1.Controls[CurCtl].Top
end;

procedure TForm1.Button21Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Form3.ShowModal;
end;

end.
